/* eshot.c */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>		/* sin,cos g߂ */
#include <sys/iocs.h>
#include "XSP2lib.H"

#define PCG_MAX	32		/* p^[f[^̌ */

static char pcg_alt[PCG_MAX + 1];	/* obfzuǗe[u */
static char pcg_dat[PCG_MAX * 128];	/* obff[^t@Cǂݍ݃obt@ */

static unsigned short pal_dat[16][15];	/* pbgf[^ */


#define ESHOT_MAX	200	/* Geő吔 */
#define ESHOT_SPEED	0.75	/* Gȇx */


/* Ge\ */
typedef struct {
	signed short x;		/* GêwW */
	signed short y;		/* @V@xW */
	unsigned char type;	/* @V@ށi=0 Ȃ疢gpj */
	signed int lx, ly;	/* 32bit X,Y W ( l = longword ) */
	signed int vx, vy;	/* 32bit X,Y x ( v = velocity ) */
} ESHOT;

ESHOT eshot[ESHOT_MAX];		/* Gẽ[N */


typedef struct {
	signed int x, y;
} VECTOR;

VECTOR xytable[256];		/* sin,cos e[u */



/* ֐vg^Cv錾 */
void EshotFree (unsigned short);



/* Q[JnɌĂ΂ */
void EshotInit (void)
{
	int i;

	for (i = 0; i < ESHOT_MAX; i++)
		eshot[i].type = 0;	/* Sgp */
}



/* GeoɌĂ΂ */
/*  : , wW, xW. px */
void EshotAlloc (unsigned short type, signed short x, signed short y, unsigned char angle)
{
	int i;

	for (i = 0; i < ESHOT_MAX; i++) {
	    /* gp̃[N */
		if (eshot[i].type == 0) {
		    /* gp̃[N */
			eshot[i].lx = x * 65536;
			eshot[i].ly = y * 65536;
			eshot[i].vx = xytable[angle].x;
			eshot[i].vy = xytable[angle].y;
			eshot[i].type = type;
			break;	/* for [v𔲂 */
		}
	}
}



/* ƂɌĂ΂ */
void EshotMove (void)
{
	int i;

	for (i = 0; i < ESHOT_MAX; i++) {
	    /* ̃[N͎gpH */
		if (eshot[i].type != 0) {
		    /* gp̃[N */
		    /* Wɑx𑫂 */
			eshot[i].lx += eshot[i].vx;	/* vx ړ */
			eshot[i].ly += eshot[i].vy;	/* vy ړ */

			eshot[i].x = eshot[i].lx / 65536;	/* lx ̐o x  */
			eshot[i].y = eshot[i].ly / 65536;	/* ly ̐o y  */

		    /* ʊOɂłGeigpj */
			if ((eshot[i].x < 0) || (eshot[i].x > 256) || (eshot[i].y < 0) || (eshot[i].y > 256)) {
				EshotFree (i);
			} else {
			    /* W(eshot[i].x,eshot[i].y), XvCg No.type, pbgR, D揇 $3f */
				xsp_set (eshot[i].x, eshot[i].y, eshot[i].type, 0x033f);
			}
		}
	}
}



/* GeɌĂ΂ */
void EshotFree (unsigned short i)
{
	eshot[i].type = 0;	/* gp */
}



int main (int argc, char *argv[])
{
	FILE *fp;
	int i, j;
	int game_over = 0;
	unsigned char angle = 0;	/* Ɍe̊px */
	unsigned char type = 1;	/* Ɍe̎ */
	int sprites;		/* XvCg̖ */

	if (argc != 1) {
		printf (
			       "GeeXĝS ESHOT.X\n"
			       "		programmed by Mitsuky <FreeSoftware>\n"
			       "ẽ[N\̂ɂĂ݂\n"
			       "16bit{16biťŒ菬_gĂ݂\n"
			       "vɒeo悤ɂĂ݂\n"
			);
		exit (-1);
	}
	printf ("f[^e[u쐬܂B\n");
	for (i = 0; i < 256; i++) {
		xytable[i].x = (signed int) (cos (2.0 * M_PI * (long) i / 256.0) * 65536.0 * ESHOT_SPEED);
		xytable[i].y = (signed int) (sin (2.0 * M_PI * (long) i / 256.0) * 65536.0 * ESHOT_SPEED);
	}


	_iocs_crtmod (10);	/* 256x256hbg OtBbN 256F Q */
	_iocs_g_clr_on ();	/* OtBbNʂ̏ */
	_iocs_sp_init ();	/* XvCg̏ */
	_iocs_sp_on ();

    /* pcg_dat Ƀp^[f[^ǂݍ */
	fp = fopen ("ESHOT.SP", "rb");
	fread (pcg_dat, sizeof (char), PCG_MAX * 128, fp);
	fclose (fp);

    /* pal_buf ɈUpbgf[^ǂݍ */
	fp = fopen ("ESHOT.PAL", "rb");
	fread (pal_dat, sizeof (unsigned short), 16 * 15, fp);
	fclose (fp);
    /* pbgf[^` */
    /* iPpbgubN16Fj ~ i15ubNԂj ` */
	{
		unsigned short *p = (unsigned short *) pal_dat;
		for (i = 1; i < 15; i++)
			for (j = 0; j < 16; j++)
				_iocs_spalet (0x80000000 | j, i, *p++);
	}

	xsp_on ();
	xsp_mode (3);
    /* p^[f[^` */
	xsp_pcgdat_set (pcg_dat, pcg_alt, sizeof (pcg_alt));

    /* OtBbNʂɐ */
	{
		struct _lineptr lp;
		lp.x1 = 0;
		lp.y1 = 128;
		lp.x2 = 255;
		lp.y2 = 128;
		lp.color = 15;
		lp.linestyle = 0xaaaa;
		_iocs_line (&lp);
		lp.x1 = 128;
		lp.y1 = 0;
		lp.x2 = 128;
		lp.y2 = 255;
		_iocs_line (&lp);
	}

	printf ("WCXeBbN\n"
		" [B] {^ƒe܂\n"
		" [A] {^ƏI܂\n");


	EshotInit ();

	do {
		xsp_vsync (0);	/* ҂ */
		j = _iocs_joyget (0);	/* WCXeBbNO */

	    /* [A] {^ꂽH */
		if ((j & 0b00100000) == 0)
			game_over = !0;		/* Q[I[o[ */

	    /* [B] {^ꂽH */
		if ((j & 0b1000000) == 0) {
			EshotAlloc (type, 144, 144, angle);	/*  type ̓GeW(144,144)Apx angle Ŕ */
			angle += 8;	/* pxi߂ */
			type++;	/* ނi߂iӖj */
			if (type > 5)
				type = 1;
		}
		EshotMove ();
		sprites = xsp_out ();	/* \ */

		printf ("e = %3d  \n\x0b", sprites);
	    /* 0x0b ̓J[\PsɈړ */
	    /* Human68K [U[Y}jA̕t^ ASCII R[h̗Q */
	} while (!game_over);

	xsp_off ();

	_iocs_crtmod (16);
	return (0);
}
